-- Louis.applescript
-- Louis

--  Created by Greg Kearney on 5/10/07.
--  Copyright 2007 greg Kearney. All rights reserved.

global interpoint
global theBrailleTable
global homedir
global configFile
global otherConfigFile


on action theObject
	if the name of theObject is "slider_cells" then
		beep
		set contents of text field "cells" of tab view item "cells_lines" of tab view "tabview" of window "main" to the contents of slider "slider_cells" of tab view item "cells_lines" of tab view "tabview" of window "main" as integer
	end if
	if the name of theObject is "slider_lines" then
		beep
		set contents of text field "lines" of tab view item "cells_lines" of tab view "tabview" of window "main" to the contents of slider "slider_lines" of tab view item "cells_lines" of tab view "tabview" of window "main" as integer
	end if
	buildCfg()
end action

on clicked theObject
	if the name of theObject is "preview" then
		buildCfg()
	end if
	if the name of theObject is "run" then
		buildRun()
	end if
	if the name of theObject is "reset1" then
		set contents of text field "cells" of tab view item "cells_lines" of tab view "tabview" of window "main" to "40"
		set contents of slider "slider_cells" of tab view item "cells_lines" of tab view "tabview" of window "main" to "40"
		set contents of text field "lines" of tab view item "cells_lines" of tab view "tabview" of window "main" to "25"
		set contents of slider "slider_lines" of tab view item "cells_lines" of tab view "tabview" of window "main" to "25"
		buildCfg()
	end if
	
	if the name of theObject is "brl_pos" or the name of theObject is "prt_pos" or the name of theObject is "brl_page_numbers" or the name of theObject is "prt_page_numbers" then
		buildCfg()
	end if
	
	if the name of theObject is "includeStyles" then
		tell open panel
			set title to "Choose file to translate"
			set prompt to "Chose a file"
			set treat packages as directories to false
			set can choose directories to false
			set can choose files to true
			set allows multiple selection to true
		end tell
		
		set theTypeList to {"txt", "cfg"} as list
		
		
		set theResult to display open panel for file types theTypeList
		if theResult is 1 then
			--set appPath to path to me
			set theIncludes to path names of open panel as list
			--log theIncludes
			set theStyles to ""
			repeat with i from 1 to the count of theIncludes
				set theStyles to theStyles & "include " & the item i of theIncludes & "
"
				log theStyles
			end repeat
			
			set contents of text field "includes" of tab view item "Processing" of tab view "tabview" of window "main" to theStyles as string
			--tell button "Build" of window "main"
			--	set enabled to true
			--end tell
		else
			set contents of text field "includes" of tab view item "Processing" of tab view "tabview" of window "main" to ""
		end if
	end if
	
	if the name of theObject is "back_format" then
		buildCfg()
	end if
	
	buildCfg()
end clicked

on awake from nib theObject
	if the name of theObject is "main" then
		--display alert
		set homedir to do shell script "echo $HOME"
		--set interpoint to "yes" as string
		set the current menu item of popup button "braillecode" of tab view item "documents" of tab view "tabview" of window "main" to menu item 1 of popup button "braillecode" of tab view item "documents" of tab view "tabview" of window "main"
		set the current menu item of popup button "configuration" of tab view item "Processing" of tab view "tabview" of window "main" to menu item 1 of popup button "configuration" of tab view item "Processing" of tab view "tabview" of window "main"
		tell tab view "tabview" of window "main"
			set current tab view item to tab view item "documents"
		end tell
	end if
	buildCfg()
	
end awake from nib





on choose menu item theObject
	set homedir to do shell script "echo $HOME" & "/lbx_files" as POSIX path
	set theName to the name of the current menu item of the popup button "configuration" of tab view item "Processing" of tab view "tabview" of window "main" as string
	if theName is "other" or theName is "custom" then
		beep
		if theName is "other" then
			set homedir to do shell script "echo $HOME" & "/lbx_files" as POSIX path
			
			tell open panel
				set title to "Choose configuration file"
				set prompt to "Chose a file"
				set treat packages as directories to false
				set can choose directories to false
				set can choose files to true
				set allows multiple selection to false
				
			end tell
			
			set theTypeList to {"cfg"} as list
			
			
			set theResult to display open panel in directory homedir for file types theTypeList
			if theResult is 1 then
				set the contents of text field "configtest" of tab view item "Processing" of tab view "tabview" of window "main" to path names of open panel as string
			else
				set the current menu item of popup button "configuration" of tab view item "Processing" of tab view "tabview" of window "main" to menu item 1 of popup button "configuration" of tab view item "Processing" of tab view "tabview" of window "main"
				set the contents of text field "configtest" of tab view item "Processing" of tab view "tabview" of window "main" to "default.cfg" as string
			end if
			
			
			
		end if
		
		if theName is "custom" then
			
			buildCfg()
			
		end if
	else
		set the contents of text field "configtest" of tab view item "Processing" of tab view "tabview" of window "main" to the name of the current menu item of the popup button "configuration" of tab view item "Processing" of tab view "tabview" of window "main" as string
	end if
	
	if theName is "savecurrent" then
		buildCfg()
		set thePrompt to "Save"
		set theTitle to "Save configuration file as"
		tell save panel
			set title to theTitle
			set prompt to thePrompt
			set required file type to "cfg"
			set treat packages as directories to false
		end tell
		
		set theResult to display save panel in directory homedir
		if theResult is 1 then
			--set sysinfo to system info
			--set myHome to home directory of sysinfo as string
			set this_story to content of text view of scroll view "scroller" of window "main" as string
			set this_file to the path name of save panel as POSIX file
			log this_file as string
			
			my write_to_file(this_story, this_file, false)
			set configFile to the path name of save panel as text
			set the contents of text field "configtest" of tab view item "Processing" of tab view "tabview" of window "main" to configFile as string
			
		else
			display alert "There was an error saving the configuration file."
			
		end if
	end if
	
end choose menu item

on changed theObject
	buildCfg()
end changed




on buildCfg()
	if the state of button "interpoint" of tab view item "cells_lines" of tab view "tabview" of window "main" is 1 then
		set interpoint to "yes" as string
	else
		set interpoint to "no" as string
	end if
	
	if the state of button "hyphenate" of tab view item "cells_lines" of tab view "tabview" of window "main" is 1 then
		set hyphenate to "yes" as string
	else
		set hyphenate to "no" as string
	end if
	
	
	if the state of button "brl_page_numbers" of tab view item "page_numbers" of tab view "tabview" of window "main" is 1 then
		set brl_page_numbers to "yes" as string
		tell matrix "brl_pos" of tab view item "page_numbers" of tab view "tabview" of window "main"
			if the title of current cell is "Top" then
				set braillePageNumberAt to "top"
			else
				set braillePageNumberAt to "bottom"
			end if
		end tell
	else
		set brl_page_numbers to "no" as string
	end if
	
	if the state of button "prt_page_numbers" of tab view item "page_numbers" of tab view "tabview" of window "main" is 1 then
		set prt_page_numbers to "yes" as string
		
		tell matrix "prt_pos_matrix" of tab view item "page_numbers" of tab view "tabview" of window "main"
			if the title of current cell is "Top" then
				set printPageNumberAt to "top"
			else
				set printPageNumberAt to "bottom"
			end if
		end tell
	else
		set prt_page_numbers to "no" as string
	end if
	--set up the beginning page number
	set beginningPageNumber to the contents of text field "startpagenumber" of tab view item "page_numbers" of tab view "tabview" of window "main"
	if beginningPageNumber is "" or beginningPageNumber < 1 then
		set beginningPageNumber to 1
	end if
	
	set theBrailleTable to the name of the current menu item of popup button "braillecode" of tab view item "documents" of tab view "tabview" of window "main" as string
	
	if theBrailleTable is "en-us-g2.ctb" or theBrailleTable is "en-GB-g2.ctb" or theBrailleTable is "en-GB-g1.ctb" or theBrailleTable is "en-US-g1.ctb" then
		if theBrailleTable is "en-us-g2.ctb" then
			set theBrailleTable to "en-us-g2.ctb,hyph_en_US.dic"
			set uncontractedTable to "en-us-g1.ctb,hyph_en_US.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		
		if theBrailleTable is "en-us-g1.ctb" then
			set theBrailleTable to "en-us-g1.ctb,hyph_en_US.dic"
			set uncontractedTable to "en-us-g1.ctb,hyph_en_US.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		
		if theBrailleTable is "en-GB-g2.ctb" then
			set theBrailleTable to "en-GB-g2.ctb,hyph_en_US.dic"
			set uncontractedTable to "en-gb-g1.utb,hyph_en_US.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		
		if theBrailleTable is "en-GB-g1.ctb" then
			set theBrailleTable to "en-GB-g1.ctb,hyph_en_US.dic"
			set uncontractedTable to "en-gb-g1.utb,hyph_en_US.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		
	else
		
		set theoffset to offset of "Se-" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_sv_SE.dic"
			set uncontractedTable to theBrailleTable & ",hyph_sv_SE.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		set theoffset to offset of "Pt" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_pt_PT.dic"
			set uncontractedTable to theBrailleTable & ",hyph_pt_PT.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		set theoffset to offset of "Pl-" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_pl_PL.dic"
			set uncontractedTable to theBrailleTable & ",hyph_pl_PL.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		set theoffset to offset of "No-" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_no_NO.dic"
			set uncontractedTable to theBrailleTable & ",hyph_no_NO.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		set theoffset to offset of "nl-" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_nl_NL.dic"
			set uncontractedTable to theBrailleTable & ",hyph_nl_NL.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		set theoffset to offset of "It-" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_it_IT.dic"
			set uncontractedTable to theBrailleTable & ",hyph_it_IT.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		set theoffset to offset of "Fr-" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_fr_Fr.dic"
			set uncontractedTable to theBrailleTable & ",hyph_fr_Fr.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		set theoffset to offset of "Es-" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_es_ES.dic"
			set uncontractedTable to theBrailleTable & ",hyph_es_ES.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		set theoffset to offset of "De-" in theBrailleTable
		if theoffset is greater than 0 then
			set theBrailleTable to theBrailleTable & ",hyph_de_DE.dic"
			set uncontractedTable to theBrailleTable & ",hyph_de_DE.dic"
			set compbrailleTable to "en-us-compbrl.ctb"
		end if
		
		set theoffset to offset of "," in theBrailleTable
		if theoffset is 0 then
			
			set uncontractedTable to theBrailleTable
			set compbrailleTable to "en-us-compbrl.ctb"
			
		end if
		
		
		
	end if
	
	
	if the state of button "nemeth" of tab view item "documents" of tab view "tabview" of window "main" is 1 then
		set compbrailleTable to "en-us-compbrl.ctb"
		set nemethTables to "mathtextTable en-us-mathtext.ctb
	mathexprTable nemeth.ctb
	editTable edittable.ctb"
	else
		set nemethTables to ""
		
	end if
	
	
	if the state of button "internet" of tab view item "Processing" of tab view "tabview" of window "main" is 1 then
		set internet to "Yes"
	else
		set internet to "No"
	end if
	
	if the state of button "addxmlhead" of tab view item "Processing" of tab view "tabview" of window "main" is 1 then
		set xmlhead to "xmlheader <?xml version='1.0' encoding='UTF8' standalone='yes'?>"
	else
		set xmlhead to ""
	end if
	
	
	
	set mycells to contents of text field "cells" of tab view item "cells_lines" of tab view "tabview" of window "main"
	set mylines to contents of text field "lines" of tab view item "cells_lines" of tab view "tabview" of window "main"
	set theStyles to contents of text field "includes" of tab view item "Processing" of tab view "tabview" of window "main" as string
	
	tell matrix "back_format" of tab view item "documents" of tab view "tabview" of window "main"
		if the name of current cell is "back_text" then
			set backFormatStr to "plain"
		else
			set backFormatStr to "html"
		end if
	end tell
	
	set outputFormat to "outputFormat
	cellsPerLine " & mycells & "
	linesPerPage " & mylines & "
	interpoint " & interpoint & "
	hyphenate " & hyphenate & "
	beginningPageNumber " & beginningPageNumber & "
	backFormat " & backFormatStr
	
	
	if brl_page_numbers is "yes" then
		set outputFormat to outputFormat & "
	braillePages " & brl_page_numbers & "
	braillePageNumberAt " & braillePageNumberAt
	end if
	
	if prt_page_numbers is "yes" then
		set outputFormat to outputFormat & "
	printPages " & prt_page_numbers & "
	printPageNumberAt " & printPageNumberAt
	end if
	--set fileEnd to "\\f"
	--set outputFormat to outputFormat & "
	--fileEnd " & fileEnd
	
	set translation to "translation
	literaryTextTable  " & theBrailleTable & "
	compbrlTable " & compbrailleTable & "
	" & nemethTables
	
	set xml to "xml
	internetAccess " & internet & "
	" & xmlhead
	
	set content of text view of scroll view "scroller" of window "main" to outputFormat & "
" & translation & "
" & xml & "
" & theStyles
	set the contents of text field "configtest" of tab view item "Processing" of tab view "tabview" of window "main" to "louis.cfg"
end buildCfg


on buildRun()
	--Here is where we do the real translation work.
	set sysinfo to system info
	set myHome to home directory of sysinfo as string
	try
		do shell script "/bin/rm $HOME/lbx_files/xml2brl.log"
	end try
	
	tell matrix "back_format" of tab view item "documents" of tab view "tabview" of window "main"
		if the title of current cell is "Text" then
			set backFormat to "text"
		else
			set backFormat to "html"
		end if
	end tell
	
	
	set theText to false
	set theEmbosserCommand to ""
	
	set filein to the contents of text field "filein" of tab view item "documents" of tab view "tabview" of window "main"
	
	
	set fileout to the contents of text field "fileout" of tab view item "documents" of tab view "tabview" of window "main"
	
	if fileout is "" then
		set fileout to filein & ".brf"
	end if
	
	set configFile to the contents of text field "configtest" of tab view item "Processing" of tab view "tabview" of window "main"
	set homedir to do shell script "echo $HOME" & "/lbx_files" as POSIX path
	
	
	if configFile is "louis.cfg" then
		--buildCfg()
		set this_story to content of text view of scroll view "scroller" of window "main" as string
		set this_file to myHome & "lbx_files:louis.cfg" as text
		my write_to_file(this_story, this_file, false)
	end if
	
	
	
	set fileinfo to info for POSIX file filein
	
	set fileext to name extension of fileinfo
	set appPath to path to me
	set antiword to POSIX path of appPath & "Contents/Resources/antiword"
	
	set homedir to do shell script "echo $HOME" & "/lbx_files"
	set abiconvert to POSIX path of homedir & "/abiconvert/abiconvert"
	
	set theEmbosser to the title of popup button "embossers" of tab view item "Processing" of tab view "tabview" of window "main"
	--display alert theEmbosser
	if fileext is "rtf" or fileext is "rtfd" then
		set thecommand to "/usr/bin/textutil -convert doc -stdout '" & filein & "' | " & antiword & " -x db - > /tmp/tmp.xml;  /usr/local/bin/xml2brl -l -f  '" & configFile & "'  /tmp/tmp.xml '" & fileout & "'"
		
		if theEmbosser is not "" then
			set theEmbosserCommand to "/bin/cat  '" & fileout & "' > " & theEmbosser
		end if
	else if fileext is "doc" then
		--set thecommand to "/usr/local/bin/antiword -x db '" & filein & "' | /usr/local/bin/xml2brl -f  '" & configFile & "' >'" & fileout & "'"
		-- set thecommand to "antiword -x db '" & filein & "' /usr/local/bin/xml2brl >$2 '" & filein & "' | /usr/local/bin/xml2brl -l -f  '" & configFile & "' - '" & fileout & "'"
		set thecommand to antiword & " -x db '" & filein & "' > /tmp/tmp.xml;  /usr/local/bin/xml2brl -l -f  '" & configFile & "'  /tmp/tmp.xml  '" & fileout & "'"
		
		if theEmbosser is not "" then
			set theEmbosserCommand to "/bin/cat  '" & fileout & "' > " & theEmbosser
		end if
	else if fileext is "wpd" then
		set theabicommand to abiconvert & " '" & filein & "' /tmp/tmp.html"
		log theabicommand
		do shell script theabicommand
		set thecommand to "/usr/local/bin/xml2brl -l -f  '" & configFile & "'  /tmp/tmp.html  '" & fileout & "'"
		log thecommand
		
		if theEmbosser is not "" then
			set theEmbosserCommand to "/bin/cat  '" & fileout & "' > " & theEmbosser
		end if
		
		
	else if fileext is "txt" then
		do shell script "/usr/bin/perl -pi -e 's/\\r/\\n/g' " & filein
		set thecommand to "< '" & filein & "' /usr/local/bin/extext | /usr/local/bin/xml2brl -l -f  '" & configFile & "' > '" & fileout & "'"
		if theEmbosser is not "" then
			set theEmbosserCommand to "/bin/cat  '" & fileout & "' > " & theEmbosser
		end if
	else if fileext is "brl" or fileext is "brf" or fileext is "dbt" then
		
		if backFormat is "text" then
			set fileout to filein & ".txt"
			set theBrailleTable to the name of the current menu item of popup button "braillecode" of tab view item "documents" of tab view "tabview" of window "main" as string
			--set theTable to do shell script "echo $HOME" & "/lbx_files/" & theBrailleTable
			--set thecommand to "/usr/local/bin/nfbtrans tm=3 kf=1 " & filein & " > " & fileout
			set thecommand to "/usr/local/bin/brl2xml -l -f  '" & configFile & "' '" & filein & "' '" & fileout & "'"
			set theText to true
		else
			set fileout to filein & ".xml"
			set theBrailleTable to the name of the current menu item of popup button "braillecode" of tab view item "documents" of tab view "tabview" of window "main" as string
			--set theTable to do shell script "echo $HOME" & "/lbx_files/" & theBrailleTable
			set thecommand to "/usr/local/bin/brl2xml -l -f  '" & configFile & "' '" & filein & "' '" & fileout & "'"
			set theText to true
			
		end if
	else
		set thecommand to "/usr/local/bin/xml2brl -l -f '" & configFile & "' '" & filein & "' '" & fileout & "'"
		log thecommand
		if theEmbosser is not "" then
			set theEmbosserCommand to "/bin/cat  '" & fileout & "' > " & theEmbosser
		end if
	end if
	--do the conversion
	--display alert theEmbosserCommand
	log thecommand
	log fileout
	if fileout is not "" then
		--try
		-- Some statements not shown
		-- Make sure panel has been loaded from nib into global property
		--load nib "busywindwo"
		--set panelWIndow to window "busy"
		-- Now display the panel
		--display panelWIndow --attached to window "main"
		--tell progress indicator "barberpole" of panelWIndow to start
		--do shell script "echo '" & thecommand & "' > /out.txt"
		tell progress indicator "progress" of tab view item "Processing" of tab view "tabview" of window "main" to start
		do shell script thecommand
		tell progress indicator "progress" of tab view item "Processing" of tab view "tabview" of window "main" to stop
		--tell progress indicator "barberpole" of panelWIndow to start
		--end try
	end if
	-- Send the embosser command if there is one
	if theEmbosser is not "" then
		try
			do shell script theEmbosserCommand
			do shell script "/bin/echo  " & (ASCII character 12) & " > " & theEmbosser
		end try
	end if
	
	--open the editor if needed
	
	if the state of button "openinte" of tab view item "Processing" of tab view "tabview" of window "main" is 1 then
		set theBrlPath_as to POSIX file fileout
		tell application "TextEdit"
			activate
			open theBrlPath_as
			if theText is not true then
				set the font of the text of the front document to "WMC Braille"
				set the size of the text of the front document to 24
			end if
			
			
		end tell
		
	end if
	
	
	try
		if exists myHome & "lbx_files:xml2brl.log" then
			set logfile to myHome & "lbx_files:xml2brl.log" as alias
			log logfile
			set alerttext to read logfile
			display alert alerttext as informational
			
		end if
	end try
	
	
	tell progress indicator "progress" of tab view item "Processing" of tab view "tabview" of window "main" to stop
	beep
	display alert "translation to " & fileout & " is complete/" attached to window "main"
	
	
end buildRun


on write_to_file(this_data, target_file, append_data)
	try
		set the target_file to the target_file as text
		set the open_target_file to 
			open for access file target_file with write permission
		if append_data is false then 
			set eof of the open_target_file to 0
		write this_data to the open_target_file starting at eof
		close access the open_target_file
		return true
	on error
		try
			close access file target_file
		end try
		return false
	end try
end write_to_file
